<?php 
/**
 * Система управления сайтом HostCMS v. 5.xx
 * Copyright © 2005-2010 ООО "Хостмэйк" (Hostmake LLC), http://www.hostcms.ru
 *
 * Модуль xsl.
 * 
 * Файл: /admin/xsl/xsl.php
 * 
 * @author Hostmake LLC
 * @version 5.x
 */
// Подключаем основные классы.
require_once('../../main_classes.php');

$admin = new Admin();

// Проверка авторизации пользователя.
$admin->admin_session_valid('Xsl');

$kernel = & singleton('kernel');

// Инсталляция всех модулей ядра.
$kernel->LoadModules(!isset($_REQUEST['JsHttpRequest']));

// Инициализация CURRENT_SITE и констант.
$admin->admin_init();

if (!isset($_REQUEST['JsHttpRequest']))
{
	do_html_header_admin($GLOBALS['MSG_xsl']['XSL_title']);
}

$admin_forms = & singleton('admin_forms');

// Добавление/редактирование информации о разделе XSL
if (isset($_REQUEST['add_xsl_dir']) || isset($_REQUEST['save_xsl_dir']))
{
	ob_start();

	if (defined('READ_ONLY') && READ_ONLY)
	{
		$kernel->ReadMode();
	}
	else
	{
		// Добавляем информацию в БД.
		include(CMS_FOLDER . 'admin/xsl/action/add_xsl_dir.php');
	}

	$message = ob_get_clean();

	$JsHttpRequest = new JsHttpRequest('UTF-8');

	// При добавлении (не сохранении) - отправляем команду на загрузку
	if (isset($_REQUEST['add_xsl_dir']))
	{
		// Отображаем форму
		include(CMS_FOLDER . 'admin/xsl/action/load_xsl_dir.php');
		$GLOBALS['_RESULT'] = $admin_forms->ShowForm(22, 'load_data');
		// Добавляем определенное выше сообщение
		$GLOBALS['_RESULT']['error'] = $message;
	}
	else
	{
		// Отправляем только сообщение о произведенных действиях
		$GLOBALS['_RESULT'] = array(
		'error' => $message,
		'form_html' => '',
		'title' => '');
	}

	echo $JsHttpRequest->LOADER;
	exit();

}

// Добавление/редактирование информации об XSL-шаблоне
if (isset($_REQUEST['add_xsl']) || isset($_REQUEST['save_xsl']))
{
	ob_start();

	if (defined('READ_ONLY') && READ_ONLY)
	{
		$kernel->ReadMode();
	}
	else
	{
		// Добавляем информацию в БД.
		include(CMS_FOLDER . 'admin/xsl/action/add_xsl.php');
	}
	
	$message = ob_get_clean();

	$JsHttpRequest = new JsHttpRequest('UTF-8');

	// При добавлении (не сохранении) - отправляем команду на загрузку
	if (isset($_REQUEST['add_xsl']) && !isset($error_edit_add_xsl))
	{
		// Отображаем форму
		include(CMS_FOLDER . 'admin/xsl/action/load_xsl_dir.php');
		$GLOBALS['_RESULT'] = $admin_forms->ShowForm(22, 'load_data');
		// Добавляем определенное выше сообщение
		$GLOBALS['_RESULT']['error'] = $message;
	}
	else
	{
		// Отправляем только сообщение о произведенных действиях
		$GLOBALS['_RESULT'] = array(
		'error' => $message,
		'form_html' => '',
		'title' => '');
	}

	echo $JsHttpRequest->LOADER;
	exit();
}

function fillXslDir($xsl_dir_parent_id, $level = 0)
{
	$xsl_dir_parent_id = intval($xsl_dir_parent_id);
	$level = intval($level);
		
	$xsl_dir = Core_Entity::factory('Xsl_Dir', $xsl_dir_parent_id);

	$return_mas = array();
	
	// Дочерние разделы
	$children_dirs = $xsl_dir->xsl_dirs->findAll();

	if (count($children_dirs))
	{
		foreach ($children_dirs as $children_dir)
		{			
			$return_mas[$children_dir->id] = str_repeat('&nbsp;&nbsp;', $level) . $children_dir->name;
			$return_mas += fillXslDir($children_dir->id, $level+1);			
		}
	}
	
	return $return_mas;
}

// Отображение форм
switch (to_int($_REQUEST['admin_forms_id']))
{
	case 22:
	default:
		{
			include(CMS_FOLDER . 'admin/xsl/action/load_xsl_dir.php');
			$admin_forms->ProcessAjax(22);
			break;
		}
}

if (!isset($_REQUEST['JsHttpRequest']))
{
	do_html_footer_admin();
}
?>